#!/usr/bin/php
<?php require_once('EasyBackup.inc'); ?>
<?php

if(($argc != 1) && ($argc != 2))
	showError("Parameter Error", "Invalid number of parameter\n Usage:\n    ".$argv[0]." [Path to file].");

// Get the Orignal location of the file and extract the file name
$OrgPath = getRealPath(getOnlyPathParameter());

// The original path must be a directory
if(!is_dir($OrgPath)) {
	showError("Parameter Error", "The given path is not a directory.");
	exit(0);
}

// Get the list of file that used to be there.
$FilesStrs = getDeletedFileList($OrgPath);

if(($FilesStrs == null) || (count($FilesStrs) == 0)) {
	$ErrMsg = "No file/folder ever been deleted from this folder.";
	showInfoGUI(null, "No file/folder ever been deleted from this folder.");
	exit(0);
}

// Get the target path
$FileToRecover = showList(
					/* Title              */ "Select the file that used to be here.",
					/* Column Header      */ array("Name", "Last Seen"),
					/* First Item         */ null,
					/* Each Item array    */ $FilesStrs,
					/* Last Item          */ null,
					/* is loop backword?  */ false,
					/* Item per page      */ 10,
					/* Text for previous  */ null,
					/* Text for next      */ null,
					/* Width and Height   */ 500, 500);
if($FileToRecover == null) exit(0);

// Get the path to the "EasyHomeRecover.php"
$AppName = $argv[0];
while(is_link($AppName)) { $AppName = readlink($AppName); }
$QuickHomeRecover = substr($AppName, 0, strlen($AppName) - strlen("EasyRecover.php"))."EasyRevert.php";

// Call the recoverer
$Cmd = $QuickHomeRecover.' "'.$OrgPath."/".$FileToRecover.'"';
echo trim(shell_exec($Cmd))."\n";
echo "Finish at at ".date("Y-m[M]-d--H:i")."\n";

// Functions ----------------------------------------------------------------------------------------------------------

function getDeletedFileList($OrgPath) {
	global $BackupDIR;

	// Locate the root for each rdiff-backup-data associated with the Original Path
	$RDiffDataDIR = trim(shell_exec('find "'.$BackupDIR.'" -name rdiff-backup-data'));
	if($RDiffDataDIR == null)
		showError("Unexpected error","The rdiff-backup-data folder is not found in the Backup folder.");

	// Get root of rdiff-backup folder in the backup folder
	$RDiffDataDIRBase = substr($RDiffDataDIR, 0, strlen($RDiffDataDIR) - strlen("rdiff-backup-data"));
	// Get the target path
	$BkPath = $RDiffDataDIRBase."rdiff-backup-data/increments/"
	             .substr(getBackupPathFromOriginal($OrgPath), strlen($RDiffDataDIRBase));

	// Get list of all the file in the Backup Path
	$Result = trim(shell_exec('ls "'.$BkPath.'"'));
	echo '$Result = '.$Result."\n";
	if($Result == null) return null;

	$BkFiles    = split("\n", $Result);
	$MFileNames = array();
	// Extract the name and see if it exist on the original side and determine the lastest date of the file
	foreach($BkFiles as $BkFile) {
		$BkFile = trim($BkFile);
		$CutCount = 0;
		if(     strEndWith(".missing",     $BkFile)) $CutCount = 26 + strlen(".missing");
		else if(strEndWith(".missing.gz",  $BkFile)) $CutCount = 26 + strlen(".missing.gz");
		else if(strEndWith(".diff",        $BkFile)) $CutCount = 26 + strlen(".diff");
		else if(strEndWith(".diff.gz",     $BkFile)) $CutCount = 26 + strlen(".diff.gz");
		else if(strEndWith(".snapshot",    $BkFile)) $CutCount = 26 + strlen(".snapshot");
		else if(strEndWith(".snapshot.gz", $BkFile)) $CutCount = 26 + strlen(".snapshot.gz");
		else if(strEndWith(".dir",         $BkFile)) $CutCount = 26 + strlen(".dir");
		else if(strEndWith(".dir.gz",      $BkFile)) $CutCount = 26 + strlen(".dir.gz");
		else continue;
		
		$BkName = substr($BkFile, 0, strlen($BkFile) - $CutCount);
		$BkDate = substr($BkFile, strlen($BkName) + 1, 19);

		if(array_key_exists($BkName, $MFileNames)) {
			$T = strtotime($BkDate);
			if($T > $MFileNames[$BkName]) $MFileNames[$BkName] = $T;
			continue;
		}
		if(file_exists($OrgPath."/".$BkName)) continue;
		$MFileNames[$BkName] = strtotime($BkDate);
	}

	if(($MFileNames == null) || (count($MFileNames) == 0)) return null;

	// Reorganize for return
	$MFNames = array();
	$MFDates = array();
	foreach(array_keys($MFileNames) as $BkName) {
		$MFNames[] = $BkName;
		$MFDates[] = date("D\d\a\y M j Y - G:i:s", $MFileNames[$BkName]);
	}
	return array($MFNames, $MFDates);
}

?>
