which bash > /tmp/null
rm -f /tmp/null

EBINST=/opt
EBPATH=$EBINST/EasyBackup

EASYBACKUP=~/.EasyBackup
EMBLEMS=~/.icons/hicolor/48x48/emblems/

EMBLEMSPREFIX="emblem-geb-"

echo "Remove EasyBackup from /opt ---------------------------------------------------"
gksudo "rm -Rf $EBPATH"

BackupDIR=""
if [ -e "$EASYBACKUP/default.ini" ]; then
	BackupDIR=$(cat $EASYBACKUP/default.ini | grep -oe "BackupDIR = .*" | grep -oe "\".*\"$")
	if [ ${#BackupDIR} -gt 2 ]; then
		BackupDIR=${BackupDIR:1:${#BackupDIR}-2};
	fi
fi

if [ "`zenity --question --text="Do you want to remove the configuration files as well?" --ok-label="Keep" --cancel-label="Delete" && echo $?`" = "" ]; then
	echo "Remove EasyBackup from user home ----------------------------------------------"
	rm -Rf "$EASYBACKUP"
fi

if [ "`zenity --question --text="Do you want to remove the nautilus emblems as well?" --ok-label="Keep" --cancel-label="Delete" && echo $?`" = "" ]; then
	echo "Remove emblems from Nautilus --------------------------------------------------"
	rm -f "$EMBLEMS/"$EMBLEMSPREFIX*.icon
	rm -f "$EMBLEMS/"$EMBLEMSPREFIX*.png
fi

if [ ${#BackupDIR} -gt 0 ]; then
	if [ "`zenity --question --text="$(printf "Do you want to remove the backup file as well?")" --ok-label="Keep" --cancel-label="Delete" && echo $?`" = "" ]; then
		echo "Remove backup repository ------------------------------------------------------"
		rm -Rf "$BackupDIR"
	fi
fi

echo "Thank you for testing EasyBackup. Please give some feed back at http://launchpad.net/gnomeeasybackup"

Msg="Thank you for testing EasyBackup.\n\n"
Msg=$Msg"Please give some feed back at:\n\thttp://launchpad.net/gnomeeasybackup."
zenity --info --text="`printf "$Msg"`"

