<?php

// ---------------------------------------------------------------------------------------------------------------------
// This file contains commonly used functions
// ---------------------------------------------------------------------------------------------------------------------

$TitlePrefix = "";

// String -----------------------------------------------------------------------------------------

/** Checks if the text starts with the prefix */
function strStartWith($Prefix, $Text) {
	if($Prefix == $Text)                return true;
	if(strlen($Prefix) > strlen($Text)) return false;
	return ($Prefix == substr($Text, 0, strlen($Prefix)));
}

/** Checks if the text ends with the suffix */
function strEndWith($Suffix, $Text) {
	if($Suffix == $Text)                return true;
	if(strlen($Suffix) > strlen($Text)) return false;
	return ($Suffix == substr($Text, strlen($Text) - strlen($Suffix)));
}

/** Add Prefix and Suffix to each elements of the array */
function addToArray($Prefix, $Array, $Suffix) {
	if($Array == null) return array();
	for($i = 0; $i < count($Array); $i++)
		if($Array[$i] != null) $Array[$i] = $Prefix.$Array[$i].$Suffix;
	return $Array;
}

// Timezone ---------------------------------------------------------------------------------------

function ensureCorrectTimeZone() {
	date_default_timezone_set(
		trim(shell_exec('echo "Etc/GMT"$(date +%z | grep -o -E "[+-]")$(date +%:z | grep -o -E "[1-9][0-9]?:")')))."\n";
}

// File -------------------------------------------------------------------------------------------

/** Returns the real path from the path (in case that the path is a symbolink) */
function getTargetPath($Path) {
	if($Path == null) return null;

	$Target = $Path;
	while(is_link($Target)) {
		$Target = readlink($Target);
		if($Target == null) return $Path;
	}
	return $Target;
}

/** Returns the real path from the path (in case that the path is in a link or include a link) */
function getRealPath($Path) {
	if($Path == null) return null;
	if(!strStartWith("/", $Path)) $Path = getcwd()."/".$Path;

	// Remove head and tail "/"
	if(strStartWith("/", $Path)) $Path = substr($Path, 1);
	if(strEndWith(  "/", $Path)) $Path = substr($Path, 0, strlen($Path) - 1);

	$Paths = split("/", $Path);
	$Target = "";
	for($i = 0; $i < count($Paths); $i++) {
		$Target .= "/".$Paths[$i];
		$NTarget = getTargetPath($Target);
		if(!strStartWith("/", $NTarget)) $NTarget = $Target."/".$NTarget;
		$Target = $NTarget;
	}
	return $Target;
}

?>
