import os;
import sys;
import datetime;
import string;
import ConfigParser;
import Libs;
import Lib_Zenity;

def EnsureNoRdiffBackupRunning():
    global IsToWait;
    while(RunShell('ps ax | grep "rdiff-backup" | grep -v "grep"') != ""):
        Lib_Zenity.Zenity.showInfo("", "Other instance of rdiff-backup is running. Please try again later.");
        if(not IsToWait): sys.exit(0);

def RunShell(Command):
    Result = "";
    for Line in os.popen(Command).readlines(): Result += Line;
    return Result.strip();

# Copied from http://code.activestate.com/recipes/65334/ written by Dirk Holtwick 
# This does not work as expected.
def LoadConfig(file):
    """
    returns a dictionary with key's of the form
    <section>.<option> and the values 
    """
    config = {};
    cp = ConfigParser.ConfigParser();
    cp.read(file);
    for sec in cp.sections():
        name = string.lower(sec)
        for opt in cp.options(sec):
            if(opt.endswith("[]")):
                if(not (name + "." + opt in config.keys())): config[name + "." + opt] = [];
                config[name + "." + opt].append(string.strip(cp.get(sec, opt)))
            else:
                config[name + "." + opt] = string.strip(cp.get(sec, opt))
    return config

# ----------------------------------------------------------------------------------------------------------------------
# This file contains initial starting up for all program of EasyBackup and commonly used utilities
# ----------------------------------------------------------------------------------------------------------------------

Program               = "EasyBackup";
Version               = "0.1";
ProgramFull           = Program + " v." + Version;
DefaultConfigFileName = "default.ini";

# Set the prefix of all dialog title
TitlePrefix = ProgramFull;

# Process the parameter ------------------------------------------------------------------------------------------------
IsForceCreate = ("-c" in sys.argv);
IsToWait      = ("-W" in sys.argv);

print "Staring " + sys.argv[0] + " at " + datetime.datetime.now().strftime("%Y-%m[%b]-%d--%H-%M") + "\n";

# Ensure no other rdiff-backup is in use
EnsureNoRdiffBackupRunning();

# Confituration ----------------------------------------------------------------------------------

ConfigFileName = DefaultConfigFileName;
if((len(sys.argv) > 1) and ("--ConfigFile" in sys.argv)):    # Select configuration
    for i in range(1, sys.argv.length):
        if(sys.argv[i] != "--ConfigFile"): continue;
        if(i == len(sys.argv)):
            print "Invalid parameter.\n";
            system.exit(0);
        
        ConfigFileName = sys.argv[i + 1];
        break;
IsNonDefaultConfig = (ConfigFileName == DefaultConfigFileName);

